#include <bits/stdc++.h>
using namespace std;
using ll = long long;

const int N = 40;
vector<pair<ll,ll>> edges[N];
ll height[N];
ll money[N];
set<pair<ll,ll>> usedInCount;

int getCount(int startV, ll n, ll k)
{
    ll curentMoney[n];
    queue<ll> q;
    q.push(startV);
    curentMoney[startV] = money[startV];
    ll counter = (money[startV] >= k);

    while (!q.empty())
    {
        int curentV = q.front();
        q.pop();

        for (auto toAndW : edges[curentV])
        {
            curentMoney[toAndW.first] = max(curentMoney[curentV] + toAndW.second, curentMoney[toAndW.first]);
            q.push(toAndW.first);
            if (curentMoney[toAndW.first] >= k) 
            {
                if (!usedInCount.contains({toAndW.first, curentMoney[toAndW.first]}))
                {
                    usedInCount.insert({toAndW.first, curentMoney[toAndW.first]});
                    counter++;
                }
            }
        }
    }

    
    return counter;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;
    for (int i = 0; i<n; i++)
    {
        int a,b; cin >> a >> b;
        height[i] = a;
        money[i] = b;
    }

    for (int i = 0; i<n; i++)
        for (int j = i+1; j<n; j++)
            if (height[i] <= height[j])
                edges[i].push_back({j, money[j]});

    /*for (int i = 0; i<n; i++){
        cout << i << ": ";
        for (auto [to, w] : edges[i])
        {
            cout << to << " " << w << "; ";
        }
        cout << endl;
    }
    cout << endl << endl;*/

    ll counter = 0;
    for (int i = 0; i<n; i++)
    {
        counter += getCount(i,n,k);
        //cout << endl << endl;
    }
    cout << counter;
}