#include <iostream>
#include <vector>

using namespace std;
using ll = int;

ll dv[10000000];
vector<ll> a;

ll AAA(ll a, ll b) {
	while (a != 0 && b != 0) {
		if (a > b) {
			a %= b;
		}
		else {
			b %= a;
		}
	}
	return a + b;
}

void build(ll l, ll r, ll id) {
	if (l == r) {
		dv[id] = a[l];
		return;
	}
	build(l, (l + r) / 2, id * 2);
	build((l + r) / 2 + 1, r, id * 2 + 1);
	dv[id] = AAA(dv[id * 2], dv[id * 2 + 1]);
}
void update(ll l, ll r, ll id, ll n) {
	if (n < l || n > r) {
		return;
	}
	if (l == r) {
		dv[id] = a[n];
		return;
	}
	update(l, (l + r) / 2, id * 2, n);
	update((l + r) / 2 + 1, r, id * 2 + 1, n);
	dv[id] = AAA(dv[id * 2], dv[id * 2 + 1]);
}
ll ans(ll l, ll r, ll id, ll l1, ll r1) {
	ll ans1, ans2;
	if (l > r1 || l1 > r) {
		return -1;
	}
	if (l >= l1 && r <= r1) {
		return dv[id];
	}
	ans1 = ans(l, (l + r) / 2, id * 2, l1, r1);
	ans2 = ans((l + r) / 2 + 1, r, id * 2 + 1, l1, r1);
	if (ans1 == -1) {
		return ans2;
	}
	if (ans2 == -1) {
		return ans1;
	}
	return AAA(ans1, ans2);
}

int main(){
	ll N, Q, inp1, l, r;
	cin >> N >> Q;
	a.resize(N);
	for (ll i = 0; i < N; i++) {
		cin >> a[i];
	}
	build(0, a.size() - 1, 1);
	while (Q--) {
		cin >> inp1 >> l >> r;
		if (inp1 == 1) {
			l--;
			a[l] = r;
			update(0, a.size() - 1, 1, l);
		}
		else {
			l--; r--;
			ll l1 = l, r1 = l;
			ll ans1 = 0;
			while (r1 <= r) {
				if (ans(0, a.size() - 1, 1, l1, r1) != 1) {
					ans1 += r1 - l1 + 1;
					r1++;
				}
				else {
					l1++;
				}
				while (r1 < l1) {
					r1++;
				}
			}
			cout << ans1 << '\n';
		}
	}
}