#include <bits/stdc++.h>
using namespace std;

const int DIM = 40;
struct House{
    long long height, gold;
} skyscapers[DIM];

int q_houses, min_needed_gold;

void input_houses(){
    cin >> q_houses >> min_needed_gold;
    for (int i = 0; i < q_houses; ++i)
        cin >> skyscapers[i].height >> skyscapers[i].gold; 
}

bool is_pos(int mask){
    int last_height = 0;
    long long sum_gold = 0;
    for (int i = 0; i < q_houses; ++i)
        if (((1 << i) & mask)){
            if (last_height <= skyscapers[i].height){
                last_height = skyscapers[i].height;
                sum_gold += skyscapers[i].gold;
            }
            else return false;
        }

/*
    for (int i = 0; i < q_houses; ++i)
        if((1 << i) & mask) cout << 1;
        else cout << 0;
    cout << ' ' << sum_gold << '\n';
*/
    return sum_gold >= min_needed_gold;
}

long long go_through(){
    long long res = 0;
    for (int i = 0; i < pow(2, q_houses); ++i){
        res += is_pos(i);
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    input_houses();

    cout << go_through() << '\n';

    return 0;    
}