#include <bits/stdc++.h>
using namespace std;

// final speedup goals/opportunities:
// - optimized нсд algorithm
// - not recalculating everything after each query

// maybe we don't need to calculate the нсд but rather predict
// whether it's going to be bigger than 1
// for example, it will always be 1 if there is a 1 in an array
//                      always be 1 if there are multiple prime numbers
//                      always be the first number if all numbers are the same

// examples of arrays where найбільший спільний дільник == 1:
// 1 1 1 1 1 1 1
// 1 3 45 6 14 6
// 2 3 5 7 11
// 2 3 4 6
// 2 13 
int isPrime(int num) {
    if (num <= 3) { return 1; }
    for (int i = 2; i<num; i++) {
        if (num % i == 0) { return 0; }
    }
    return 1;
}

int getNsd(int* arr, int l, int r) {
    // todo: optimizations for one-number and two-number arrays
    int firstNum = arr[l];
    int allsame = 1;
    int lastPrime = 0;
    for (int i = l; i<=r; i++) {
        int numHere = arr[i];
        // is there a 1 in the array?
        if (numHere == 1) { return 1; }

        allsame = allsame & numHere == firstNum;
        if (isPrime(numHere)) {
            // two prime numbers?
            if (lastPrime != 0 && lastPrime != numHere) {
                return 1;
            }
            lastPrime = numHere;
        }
    }
    // are all of them the same?
    if (allsame) {return firstNum;}
    return 2; // placeholder
}

void breakDownArrayByPrime(int* arr, int count) {

}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin>>n>>q;
    int* a = (int*)malloc(n*sizeof(int));
    for (int i = 0; i<n; i++) {
        int numHere;
        cin >> numHere;
        a[i] = numHere;
    }
    for (int i = 0; i<q; i++) {
        int queryKind;
        cin >> queryKind;
        if (queryKind == 1) {
            int x, v;
            cin >> x >> v;
            a[x-1] = v;
        } else {
            // remember to reduce the l and r bounds by 1!
            int l, r;
            cin>>l>>r;
            l--;
            r--;
            // array optimization ideas:
            // - split arrays by 1
            // - if two prime numbers exist, break down further into 3 pieces
        }
    }
}
