#include<iostream>
#include<ios>
#include<vector>
#include<unordered_map>
#include<utility>
#include<algorithm>
#include<queue>
using namespace std;
typedef long long ll;

int n, ans;
ll k;

struct Node {
	vector<int> neighbors;
	int coins = 0;
};

unordered_map<int, Node> g;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> k;
	vector<int> h(n);
	cin >> h[0] >> g[0].coins;
	for (int i = 1; i < n; i++) {
		cin >> h[i] >> g[i].coins;
		for (int j = i - 1; j >= 0; j--) {
			if (h[j] <= h[i]) {
				g[j].neighbors.push_back(i);
			}
		}
	}

	for (int i = 0; i < n; i++) {
		queue<pair<int, int>> q;
		q.push(make_pair(i, g[i].coins));
		vector<vector<int>> visited(n, vector<int>(0));
		visited[i].push_back(g[i].coins);
		while (!q.empty()) {
			vector<int> curr_neig = g[q.front().first].neighbors;
			int curr_coins = q.front().second;
			q.pop();
			for (int j = 0; j < curr_neig.size(); j++) {
				q.push(make_pair(curr_neig[j], curr_coins + g[curr_neig[j]].coins));
				visited[j].push_back(curr_coins + g[curr_neig[j]].coins);
			}
		}

		for (int j = 0; j < n; j++) {
			for (int t = 0; t < visited[j].size(); t++) {
				if (visited[j][t] >= k) ans++;
			}
		}
	}

	cout << ans;
}