#include<iostream>
#include<ios>
#include<vector>
#include<unordered_map>
#include<utility>
#include<queue>
using namespace std;
typedef long long ll;

int n, ans;
ll k;
ll sum;

unordered_map<int, vector<int>> g;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> k;
	vector<int> h(n);
	vector<int> c(n);
	cin >> h[0] >> c[0];
	for (int i = 1; i < n; i++) {
		cin >> h[i] >> c[i];
		sum += c[i];
		for (int j = i - 1; j >= 0; j--) {
			if (h[j] <= h[i]) {
				g[j].push_back(i);
			}
		}
	}

	if (sum < k) {
		cout << 0;
		return 0;
	}

	for (int i = 0; i < n; i++) {
		queue<pair<int, ll>> q;
		q.push(make_pair(i, c[i]));
		if (c[i] >= k) ans++;
		while (!q.empty()) {
			vector<int> curr_neig = g[q.front().first];
			ll curr_coins = q.front().second;
			q.pop();
			for (int j = 0; j < curr_neig.size(); j++) {
				q.push(make_pair(curr_neig[j], curr_coins + c[curr_neig[j]]));
				if (curr_coins + c[curr_neig[j]] >= k) ans++;
			}
		}
	}

	cout << ans;
}