#include<iostream>
#include<ios>
#include<vector>
#include<unordered_map>
#include<utility>
#include<queue>
#include<cmath>
using namespace std;
typedef long long ll;

int n, m;
unordered_map<int, vector<int>> g;
ll ans;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		g[a].push_back(b);
		g[b].push_back(a);
	}

	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;

		queue<int> q;
		vector<int> visited(n + 1, 0);
		q.push(a);
		visited[a] = 1;
		while (!q.empty()) {
			vector<int> neigh = g[q.front()];
			int node = visited[q.front()];
			q.pop();
			for (int i = 0; i < neigh.size(); i++) {
				if (visited[neigh[i]] == 0) {
					q.push(neigh[i]);
					visited[neigh[i]] = node + 1;
				}
			}
		}

		ll temp = (n - 1) - (visited[b] - 1);
		temp = pow(2, temp) * 2;
		ans += temp;
	}

	cout << ans;
}