#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
const ll INF = 3*1e5;
const ll mod = 1e9+7;
ll who[INF];
ll dsu[INF];
ll pls[INF];
ll deep[INF];
ll dp[INF][30];
vector<ll> graph[INF];
ll ff, ss;
ll fff, sss;
vector<ll> f;
vector<ll> s;
void dfs(ll v, ll p, ll d){
    deep[v]=d;
    dp[v][0]=p;
    for(auto element : graph[v]) if(element!=p) dfs(element, v, d+1);
}
ll up(ll v, ll far){
    ll now = 0;
    while(far!=0){
        if(far%2) v=dp[v][now];
        far/=2;
        now++;
    }
    return v;
}
void up1(ll v, ll want){
    if(v==want) return;
    if(pls[v]==0){
        f.push_back(v);
        v=dp[v][0];
        up1(v, want);
    }
    else{
        ff=pls[v];
        fff=who[v];
        return;
    }
}
void up2(ll v, ll want){
    if(v==want) return;
    if(pls[v]==0){
        s.push_back(v);
        v=dp[v][0];
        up2(v, want);
    }
    else{
        ss=pls[v];
        sss=who[v];
        return;
    }
}
ll lca(ll first, ll second){
    ll dif = abs(deep[first]-deep[second]);
    if(deep[first]>deep[second]) first=up(first, dif);
    else if(deep[first]<deep[second]) second=up(second, dif);
    if(first==second) return first;
    else{
        for(ll i = 29; i>=0; i--){
            if(dp[first][i]!=dp[second][i]){
                first=dp[first][i];
                second=dp[second][i];
            }
        }
        return dp[first][0];
    }
}
ll parent(ll v){
    if(dsu[v]==v) return v;
    else{
        ll t = parent(dsu[v]);
        dsu[v]=t;
        return t;
    }
}
void unite(ll v, ll p){
    if(dsu[v]==v) dsu[v]=p;
    else{
        unite(dsu[v], p);
        dsu[v]=p;
    }
}
int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, m;
    cin >> n >> m;
    for(ll i = 0; i<n-1; i++){
        ll first, second;
        cin >> first >> second;
        first--;
        second--;
        graph[first].push_back(second);
        graph[second].push_back(first);
    }
    for(ll i = 0; i<n; i++) dsu[i]=i;
    dfs(0, 0, 0);
    for(ll i = 1; i<30; i++){
        for(ll j = 0; j<n; j++){
            dp[j][i]=dp[dp[j][i-1]][i-1];
        }
    }
    for(ll i = 0; i<m; i++){
        ll first, second;
        cin >> first >> second;
        first--;
        second--;
        ll v = lca(first, second);
        f.clear();
        s.clear();
        ff=-1;
        ss=-1;
        up1(first, v);
        up2(second, v);
        if(ff==-1 && ss==-1){
            for(auto element : f) pls[element]=1;
            for(auto element : s) pls[element]=2;
            for(auto element : f) who[element]=i;
            for(auto element : s) who[element]=i;
        }
        else if(ff==-1){
            ll t = parent(fff);
            dsu[i]=t;
            if(ss==1) ff=2;
            else ff=1;
            for(auto element : f) pls[element]=ff;
            for(auto element : s) pls[element]=ss;
            for(auto element : f) who[element]=i;
            for(auto element : s) who[element]=i;
        }
        else if(ss==-1){
            ll t = parent(sss);
            dsu[i]=t;
            if(ff==1) ss=2;
            else ss=1;
            for(auto element : f) pls[element]=ff;
            for(auto element : s) pls[element]=ss;
            for(auto element : f) who[element]=i;
            for(auto element : s) who[element]=i;
        }
        else{
            if(ff==ss){
                cout << "0";
                return 0;
            }
            else{
                ll t = parent(fff);
                unite(sss, t);
                dsu[i]=t;
                for(auto element : f) pls[element]=ff;
                for(auto element : s) pls[element]=ss;
                for(auto element : f) who[element]=i;
                for(auto element : s) who[element]=i;
            }
        }
    }
    ll now = 1;
    set<ll> help;
    for(ll i = 0; i<m; i++) help.insert(parent(i));
    for(ll i = 0; i<help.size(); i++){ now*=2; now%=mod;}
    for(ll i = 1; i<n; i++) if(pls[i]==0){ now*=2; now%=mod;}
    cout << now;
}