#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
const ll INF = 3*1e5;
const ll mod = 1e9+7;
struct node{ll first, second, third;};
ll who[INF];
ll dsu[INF];
ll can[INF];
ll pls[INF];
ll deep[INF];
bool was[INF];
ll dp[INF][30];
vector<ll> graph[INF];
ll ff, ss;
ll fff, sss;
vector<ll> f;
vector<ll> s;
void dfs(ll v, ll p, ll d){
    deep[v]=d;
    dp[v][0]=p;
    for(auto element : graph[v]) if(element!=p) dfs(element, v, d+1);
}
ll up(ll v, ll far){
    ll now = 0;
    while(far!=0){
        if(far%2) v=dp[v][now];
        far/=2;
        now++;
    }
    return v;
}
void up1(ll v, ll want){
    if(v==want) return;
    if(pls[v]==0){
        f.push_back(v);
        v=dp[v][0];
        up1(v, want);
    }
    else{
        ff=pls[v];
        fff=who[v];
        return;
    }
}
void up2(ll v, ll want){
    if(v==want) return;
    if(pls[v]==0){
        s.push_back(v);
        v=dp[v][0];
        up2(v, want);
    }
    else{
        ss=pls[v];
        sss=who[v];
        return;
    }
}
node lca(ll first, ll second){
    pair<ll, ll> need = {0, 0};
    ll dif = abs(deep[first]-deep[second]);
    if(deep[first]>deep[second]){ first=up(first, dif); need.first+=dif;}
    else if(deep[first]<deep[second]){ second=up(second, dif); need.second+=dif;}
    if(first==second) return {first, need.first, need.second};
    else{
        ll pref[30];
        pref[0]=1;
        for(ll i = 1; i<30; i++) pref[i]=pref[i-1]*2;
        for(ll i = 29; i>=0; i--){
            if(dp[first][i]!=dp[second][i]){
                first=dp[first][i];
                second=dp[second][i];
                need.first+=pref[i];
                need.second+=pref[i];
            }
        }
        return {dp[first][0], need.first+1, need.second+1};
    }
}
ll parent(ll v){
    if(dsu[v]==v) return v;
    else{
        ll t = parent(dsu[v]);
        dsu[v]=t;
        return t;
    }
}
void unite(ll v, ll p){
    if(dsu[v]==v) dsu[v]=p;
    else{
        unite(dsu[v], p);
        dsu[v]=p;
    }
}
void helper(ll v){
    for(auto element : graph[v]){
        if(element!=dp[v][0]){
            if(can[element]>=2){
                ll t = parent(who[v]);
                unite(who[element], t);
            }
        }
    }
}
int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, m;
    cin >> n >> m;
    for(ll i = 0; i<n-1; i++){
        ll first, second;
        cin >> first >> second;
        first--;
        second--;
        graph[first].push_back(second);
        graph[second].push_back(first);
    }
    for(ll i = 0; i<INF; i++) dsu[i]=i;
    ll y = 0;
    for(ll i = 0; i<n; i++) if(graph[i].size()==1) y=i;
    dfs(y, y, 0);
    for(ll i = 1; i<30; i++){
        for(ll j = 0; j<n; j++){
            dp[j][i]=dp[dp[j][i-1]][i-1];
        }
    }
    ll counter = 0;
    for(ll i = 0; i<m; i++){
        ll first, second;
        cin >> first >> second;
        first--;
        second--;
        node need = lca(first, second);
        ll v = need.first;
        f.clear();
        s.clear();
        ff=-1;
        ss=-1;
        fff=-1;
        sss=-1;
        up1(first, v);
        up2(second, v);
        can[first]=max(can[first], need.second);
        can[second]=max(can[second], need.third);
        if(f.size()+s.size()==0) counter++;
        if(ff==-1 && ss==-1){
            ff=1;
            ss=2;
            if(need.second==0){
                if(deep[first]>deep[second]){
                    ss=2;
                }
                else ss=1;
            }
            else{
                if(deep[second]>deep[first]){
                    ff=2;
                }
                else ff=1;
            }
            was[first]=true;
            for(auto element : f) pls[element]=ff;
            for(auto element : s) pls[element]=ss;
            for(auto element : f) who[element]=i;
            for(auto element : s) who[element]=i;
        }
        else if(ff==-1){
            if(ss==1) ff=2;
            else ff=1;
            for(auto element : f) pls[element]=ff;
            for(auto element : s) pls[element]=ss;
            for(auto element : f) who[element]=i;
            for(auto element : s) who[element]=i;
        }
        else if(ss==-1){
            if(ff==1) ss=2;
            else ss=1;
            for(auto element : f) pls[element]=ff;
            for(auto element : s) pls[element]=ss;
            for(auto element : f) who[element]=i;
            for(auto element : s) who[element]=i;
        }
        else{
            if(ff==ss){
                cout << "0";
                return 0;
            }
            else{
                for(auto element : f) pls[element]=ff;
                for(auto element : s) pls[element]=ss;
                for(auto element : f) who[element]=i;
                for(auto element : s) who[element]=i;
            }
        }
        ll f = who[up(first, need.second-1)];
        ll s = who[up(second, need.third-1)];
        ll t = parent(f);
        unite(s, t);
        
    }
    for(ll i = 1; i<n; i++) helper(i);
    ll now = 1;
    set<ll> help;
    for(ll i = 0; i<m; i++) help.insert(parent(i));
    for(ll i = 0; i<help.size()-counter; i++){ now*=2; now%=mod;}
    for(ll i = 0; i<n; i++){
        if(i==y) continue;
        if(pls[i]==0){ now*=2; now%=mod;}
    }
    cout << now;
}