#include <bits/stdc++.h>
using namespace std;
using ll=long long;
const ll mod=1e9+7;
const ll nmax=3e5+5;


struct elem{
    ll l, r;
};

vector<ll>adj[nmax];
ll cnt[nmax];
bool vis[nmax];

vector<ll>v;

ll dfs(ll node, ll per){
    vis[node]=1;
    for(auto u : adj[node]){
        if(u!=per) return dfs(u, node);
    }
    return node;
}

void dfs2(ll node, ll per, ll cur){
    cnt[node]=cur;
    ++cur;
    v.push_back(node);
    for(auto u : adj[node]){
        if(u!=per) dfs2(u, node, cur);
    }
}

bool comp(elem a, elem b){
    return a.l < b.l;
}

ll poww(ll x){
    ll ans=1;
    while(x--) ans=ans*2%mod;
    return ans;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n, m;
    cin >> n >> m;
    
    
    ll v1, v2;
    for (int i = 1; i <= n-1; i++){
        cin >> v1 >> v2;
        adj[v1].push_back(v2);
        adj[v2].push_back(v1);
    }

    ll first=dfs(1, -1);
    //cout << first;

    for (int i = 1; i <= n; i++){
        if(!vis[i]){
            cout << 0;
            return 0;
        }
    }
    

    dfs2(first, -1, 1);
    //for (int i = 1; i <= n; i++) cout << cnt[i] << ' ';
    //cout << '\n';
    //for(auto u : v) cout << u << ' ';
    


    elem p[m+3];

    for (int i = 1; i <= m; i++){
        cin >> p[i].l >> p[i].r;
        p[i].l=cnt[p[i].l];
        p[i].r=cnt[p[i].r];
        if(p[i].l > p[i].r) swap(p[i].l, p[i].r);
    }

    sort(p+1, p+m+1, comp);

    //cout << '\n';
    //for (int i = 1; i <= m; i++) cout << p[i].l <<' ' << p[i].r << '\n'; 

    vector<elem>pp;
    ll curl=p[1].l;
    ll curr=p[1].r;
    for (int i = 2; i <= m; i++){
        if(p[i].l < curr) curr=max(p[i].r, curr);
        else{
            pp.push_back({curl, curr});
            curl=p[i].l;
            curr=p[i].r;
        }
    }
    pp.push_back({curl, curr});

    
    //cout << '\n';
    ll sum=0;
    for(auto u : pp){
        //cout << u.l << ' ' << u.r << '\n';
        sum+=u.r-u.l+1;
    }

    ll nall=n-sum+pp.size();
    //cout << sum << ' ' << nall;

    
    cout << poww(nall);
    
    
    
    
    
    



}
