#include <bits/stdc++.h>
using namespace std;
using ll = long long;

const int N = 1e5+1;

int firstInd[26] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
int countOfWords[26] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
int stepFromFirst[26] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

vector<string> wordList;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;
    for (int i = 0; i<n; i++){
        string s; cin >> s;
        wordList.push_back(s);
        countOfWords[int(s[0])-int('a')]++;
    }
    sort(wordList.begin(), wordList.end());

    int lastSettedIndexIndex = -1;
    for (int i = 0; i<26; i++)
    {
        firstInd[i] = -1;
        if (countOfWords[i] > 0) {
            if (lastSettedIndexIndex == -1)
                firstInd[i] = 0;
            else
                firstInd[i] = firstInd[lastSettedIndexIndex] + countOfWords[lastSettedIndexIndex];
            stepFromFirst[i] = 0;
            lastSettedIndexIndex = i;
        }
    }

    /*for (int i = 0; i<26; i++)
    {
        cout << firstInd[i] << " " << lastMinInd[i] << " " << countOfWords[i] << endl;
    }*/

    for (int i = 0; i<k; i++)
    {
        char s; cin >> s;
        int letterInd = int(s)-int('a');
        int curentIndex = firstInd[letterInd] + stepFromFirst[letterInd];
        cout << wordList[curentIndex] << endl;
        stepFromFirst[letterInd] = (stepFromFirst[letterInd]+1)%countOfWords[letterInd];
    }
}
