#include <bits/stdc++.h>
using namespace std;
using ll = long long;

const int N = 40;
vector<pair<int,ll>> edges[N];
int height[N];
int money[N];

int getCount(int startV, int n, int k)
{
    vector<ll> curentMoney[n];
    queue<int> q;
    q.push(startV);
    curentMoney[startV].push_back(money[startV]);

    while (!q.empty())
    {
        int curentV = q.front();
        q.pop();

        for (auto toAndW : edges[curentV])
        {
            for (int i : curentMoney[curentV])
                curentMoney[toAndW.first].push_back(i + toAndW.second);
            q.push(toAndW.first);
        }
    }

    int counter = 0;
    for (int i = 0; i<n; i++)
    {
        cout << i << ": ";
        for (ll j : curentMoney[i])
        {
            //cout << j << " ";
            if (j >= k)
                counter ++;
        }
    }
    return counter;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;
    for (int i = 0; i<n; i++)
    {
        int a,b; cin >> a >> b;
        height[i] = a;
        money[i] = b;
    }

    for (int i = 0; i<n; i++)
        for (int j = i+1; j<n; j++)
            if (height[i] <= height[j])
                edges[i].push_back({j, money[j]});

    /*for (int i = 0; i<n; i++){
        cout << i << ": ";
        for (auto [to, w] : edges[i])
        {
            cout << to << " " << w << "; ";
        }
        cout << endl;
    }
    cout << endl << endl;*/

    int counter = 0;
    for (int i = 0; i<n; i++)
    {
        counter += getCount(i,n,k);
        //cout << endl << endl;
    }
    cout << counter;
}
