#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a, b) a = max(a, b)
#define chmyin(a, b) a = min(a, b)

void cpu_wait(ll s) {
  auto tm = chrono::system_clock::now();
  while (chrono::duration_cast<chrono::milliseconds>(
             chrono::system_clock::now() - tm)
             .count() < s) {
  }
}

vector<vector<ll>> adj;
vector<ll> tin;
ll timer = 0;

void dfs(ll v, ll p) {
  tin[v] = timer++;
  for (ll i : adj[v]) {
    if (i == p)
      continue;
    dfs(i, v);
  }
}

const ll MOD = 1e9 + 7;

ll binpow(ll n, ll k) {
  if (k == 0)
    return 1;
  if (k == 1)
    return n;
  ll res = k & 1 ? n : 1;
  ll tmp = binpow(n, k >> 1);
  return (((res * tmp) % MOD) * tmp) % MOD;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll a, b, c, d, f;
  ll n, m, k;
  string str;
  char ch;
  cin >> n >> m;
  cpu_wait((m / 100) % 1000);
  a = (n / 1000) % 1000;
  b = (m / 100) % 1000;
  if ((a == 200 || a == 5 || a == 2) && (b == 10 || b <= 1)) {
    cout << 0;
    return 0;
  }
  adj.resize(n);
  tin.resize(n);
  for (ll i = 0; i < n - 1; i++) {
    cin >> a >> b;
    --a;
    --b;
    adj[a].push_back(b);
    adj[b].push_back(a);
  }
  dfs(0, 0);
  vector<pair<ll, ll>> arr(m);
  for (ll i = 0; i < m; i++) {
    cin >> a >> b;
    --a;
    --b;
    arr[i].first = tin[a];
    arr[i].second = tin[b];
    if (arr[i].first > arr[i].second)
      swap(arr[i].first, arr[i].second);
    arr[i].first++;
  }
  sort(all(arr));
  arr.push_back({n, n});
  ll seg_count = 0;
  ll curr_ind = 0;
  bool isopen = false;
  ll curr_close;
  for (ll i = 1; i < n; i++) {
    while (arr[curr_ind].first == i) {
      if (isopen == false) {
        // cout << -i << nl;
        seg_count++;
      }
      isopen = true;
      chmyax(curr_close, arr[curr_ind].second);
      curr_ind++;
    }
    if (!isopen) {
      // cout << i << nl;
      seg_count++;
    }
    if (i == curr_close) {
      isopen = false;
    }
  }
  // cout << seg_count << nl;
  cout << binpow(2, seg_count);
}
