#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

ll N, K, ans = 0;
vector<ll> H;
vector<ll> G;

void recurs(ll id, ll num) {
	num += G[id];
	if (num >= K) {
		ans++;
	}
	for (ll i = id + 1; i < N; i++) {
		if (H[i] >= H[id]) {
			recurs(i, num);
		}
	}
}

int main() {
	cin >> N >> K;
	H.resize(N);
	G.resize(N);
	for (ll i = 0; i < N; i++) {
		cin >> H[i] >> G[i];
	}
	for (ll i = 0; i < N; i++) {
		recurs(i, 0);
	}
	cout << ans << '\n';
}