#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

vector<ll> sorted;
vector<vector<ll>> a;

void dfs(ll ind, ll prev) {
	sorted.push_back(ind);
	for (ll i = 0; i < a[ind].size(); i++) {
		if (a[ind][i] != prev) {
			dfs(a[ind][i], ind);
		}
	}
}

int main() {
	ll N, M, inp1, inp2, sortst = 0, ans = 1;
	cin >> N >> M;
	vector<bool> aba(N);
	sorted.resize(N);
	a.resize(N);
	for (ll i = 0; i < N - 1; i++) {
		cin >> inp1 >> inp2;
		inp1--; inp2--;
		a[inp1].push_back(inp2);
		a[inp2].push_back(inp1);
	}
	for (ll i = 0; i < N; i++) {
		if (a[i].size() == 1) {
			sortst = i;
			break;
		}
	}
	dfs(sortst, -1);
	for (ll i = 0; i < M; i++) {
		cin >> inp1 >> inp2;
		inp1--; inp2--;
		for (ll j = inp1; j < inp2; j++) {
			aba[j] = true;
		}
	}
	if (aba[0]) {
		ans *= 2;
	}
	for (ll i = 1; i < N; i++) {
		if (!aba[i - 1] && aba[i]) {
			ans *= 2;
		}
		else if (!aba[i]) {
			ans *= 2;
		}
	}
	cout << ans << '\n';
}