#include <iostream>
#include <vector>
#include <map>

using namespace std;
using ll = long long;

vector<ll> sorted;
map<ll, ll> sorted1;
vector<vector<ll>> a;

void dfs(ll ind, ll prev) {
	sorted1[ind] = sorted.size();
	sorted.push_back(ind);
	for (ll i = 0; i < a[ind].size(); i++) {
		if (a[ind][i] != prev) {
			dfs(a[ind][i], ind);
		}
	}
}

int main() {
	ll N, M, inp1, inp2, sortst = 0, ans = 1;
	cin >> N >> M;
	vector<ll> aba(N);
	a.resize(N);
	for (ll i = 0; i < N - 1; i++) {
		cin >> inp1 >> inp2;
		inp1--; inp2--;
		a[inp1].push_back(inp2);
		a[inp2].push_back(inp1);
	}
	for (ll i = 0; i < N; i++) {
		if (a[i].size() == 1) {
			sortst = i;
			break;
		}
	}
	dfs(sortst, -1);
	for (ll i = 0; i < M; i++) {
		cin >> inp1 >> inp2;
		inp1--; inp2--;
		if (sorted1[inp1] < sorted1[inp2]) {
			aba[sorted1[inp1]]++;
			aba[sorted1[inp2]]--;
		}
		else {
			aba[sorted1[inp1]]--;
			aba[sorted1[inp2]]++;
		}
	}
	ll sum = 0;
	for (ll i = 0; i < N; i++) {
		sum += aba[i];
		if (sum == 1 && aba[i] == 1) {
			ans *= 2;
		}
		if (sum == 0 && i != N - 1) {
			ans *= 2;
		}
	}
	cout << 0 << '\n';
}