#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using ld = long double;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int k, n;
    cin >> k >> n;

    vector<vector<string>> words_by_letter(26, vector<string>{});

    for (int i = 0; i < k; i++) {
        string word;
        cin >> word;

        words_by_letter[word[0] - 'a'].push_back(word);
    }

    for (int i = 0; i < 26; i++) {
        sort(words_by_letter[i].begin(), words_by_letter[i].end());
    }

    vector<int> indexes_by_letter(26, 0);

    for (int i = 0; i < n; i++) {
        char letter;
        cin >> letter;

        int letter_index = letter - 'a';

        cout << words_by_letter[letter_index][indexes_by_letter[letter_index]++] << "\n";
        indexes_by_letter[letter_index] %= words_by_letter[letter_index].size();
    }

    return 0;
}
