#include <bits/stdc++.h>

using namespace std;

int n, m, timer = 0, a, b, ans;
int tin[300005], tout[300005], boss[300005], up[300005];
vector<pair<int, int>> A[300005];
int d[300005][20];

int dfs(int v, int p, int e){
    tin[v] = timer++;
    d[v][0] = p;
    for (int i = 1; i < 20; i++)
        d[v][i] = d[d[v][i-1]][i-1];
    up[v] = e;
    for (auto x : A[v])
        if (p != x.first) dfs(x.first, v, x.second);
    tout[v] = timer++;
}

bool upper(int a, int b){
    return (tin[a] < tin[b] && tout[a] > tout[b]);
}

int lca(int a, int b){
    if (upper(a, b)) return a;
    if (upper(b, a)) return b;
    for (int i = 19; i >= 0; i--)
        if (!upper(d[a][i], b)) a = d[a][i];
    return d[a][0];
}

int findBoss(int x){
    if (boss[x] == x) return x;
    return boss[x] = findBoss(boss[x]);
}

void unite(int a, int b){
    int ba = findBoss(a), bb = findBoss(b);
    if (ba != bb) ans--;
    boss[ba] = bb;
}

void fn(int a, int b){
    if (b == 1) swap(a, b);
    if (a == 1){
        while (d[b][0] != d[a][0]){
            unite(up[b], up[d[b][0]]);
            b = d[b][0];
        }
    }
    while (!upper(d[a][0], b)){
        unite(up[a], up[d[a][0]]);
        a = d[a][0];
    }
    while (d[b][0] != d[a][0]){
        unite(up[b], up[d[b][0]]);
        b = d[b][0];
    }
    unite(up[a], up[b]);
}

long long binPow(long long x, long long a, long long p){
    if (a == 0) return 1;
    if (a%2 == 0){
        int k = binPow(x, a/2, p);
        return (k*k)%p;
    }
    return (binPow(x, a/2, p)*x)%p;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    ans = n-1;
    for (int i = 1; i < n; i++){
        boss[i] = i;
        cin >> a >> b;
        A[a].push_back({b, i});
        A[b].push_back({a, i});
    }
    for (int i = 0; i < 20; i++)
        d[1][i] = 1;
    dfs(1, 1, -1);
    for (int i = 0; i < m; i++){
        cin >> a >> b;
        fn(a, b);
    }
    cout << binPow(2, ans, 1e9+7);
    return 0;
}






























