#include <bits/stdc++.h>

using namespace std;

int n, m, timer = 0, v1, v2, fre, cnt = 0, ans, l;
int tin[300005], tout[300005], up[300005];
int type[300005];
vector<pair<int, int>> A[300005];
int d[300005][20];

int dfs(int v, int p, int e){
    tin[v] = timer++;
    d[v][0] = p;
    for (int i = 1; i < 20; i++)
        d[v][i] = d[d[v][i-1]][i-1];
    up[v] = e;
    for (auto x : A[v])
        if (p != x.first) dfs(x.first, v, x.second);
    tout[v] = timer++;
}

bool upper(int a, int b){
    return (tin[a] < tin[b] && tout[a] > tout[b]);
}

int lca(int a, int b){
    if (upper(a, b)) return a;
    if (upper(b, a)) return b;
    for (int i = 19; i >= 0; i--)
        if (!upper(d[a][i], b)) a = d[a][i];
    return d[a][0];
}

void fn(int a, int b){
    int aa = a;
    int bb = b;
    l = lca(a, b);
    bool b1 = 0, b2 = 0;

    if (!upper(a, b))
        while (a != l){
            if (type[up[a]] == 1) b1 = 1;
            else if (type[up[a]] == 2) b2 = 1;
            a = d[a][0];
        }

    if (!upper(b, a))
        while (b != l){
            if (type[up[b]] == 1) b2 = 1;
            else if (type[up[b]] == 2) b1 = 1;
            b = d[b][0];
        }


    if (b1 && b2){
        ans = -1;
        return;
    }
    if (!(b1 || b2)) cnt++;
    a = aa; b = bb;


    if (b2){
        if (!upper(a, b))
            while (a != l){
                if (type[up[a]] == 0) fre--;
                type[up[a]] = 2;
                a = d[a][0];
            }

        if (!upper(b, a))
            while (b != l){
                if (type[up[b]] == 0) fre--;
                type[up[b]] = 1;
                b = d[b][0];
            }
    }




    else{
        if (!upper(a, b))
            while (a != l){
                if (type[up[a]] == 0) fre--;
                type[up[a]] = 1;
                a = d[a][0];
            }

        if (!upper(b, a))
            while (b != l){
                if (type[up[b]] == 0) fre--;
                type[up[b]] = 2;
                b = d[b][0];
            }
    }
}

long long binPow(long long x, long long a, long long p){
    if (a == 0) return 1;
    int k = binPow(x, a/2, p);
    if (a%2 == 0)
        return (k*k)%p;
    return (k*k*x)%p;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    fre = n-1;
    for (int i = 1; i < n; i++){
        type[i] = 0;
        cin >> v1 >> v2;
        A[v1].push_back({v2, i});
        A[v2].push_back({v1, i});
    }
    for (int i = 0; i < 20; i++)
        d[1][i] = 1;
    dfs(1, 1, 0);
    for (int i = 0; i < m; i++){
        cin >> v1 >> v2;
        fn(v1, v2);
        if (ans == -1){
            cout << 0;
            return 0;
        }
    }
    ans = fre + cnt;
    cout << binPow(2, ans, 1e9+7);

    return 0;
}






























