#include <bits/stdc++.h>
using namespace std;

vector<pair<int,string>> words[26];
int q_words;

bool comp(pair<int, string>& A, pair<int, string>& B){
    return A.first < B.first || (A.first == B.first && A.second < B.second);
}

void input_words(){
    string word;
    for (int i = 0; i < q_words; ++i){
        cin >> word;
        words[word[0] - 'a'].push_back({0, word});
    }
    for (int i = 0; i < 26; ++i)
        sort(words[i].begin(), words[i].end(), comp);
}

void insert_word(pair<int, string> &word, int ind){
    int left = 0, right = words[ind].end() - words[ind].begin(), mid;

    while (left < right){
        mid = (left + right) >> 1;
        if (!comp(word, words[ind][mid]))
            left = mid + 1;
        else
            right = mid;
    }

    words[ind].insert(words[ind].begin() + left, word);
}

void output_words(){
    bool P;
    for (int i = 0; i < 26; ++i){
        P = false;
        for (pair<int, string> word : words[i]){
            cout << word.second << ' ';
            P = true;
        }
        if (P)
            cout << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int q_chars; cin >> q_words >> q_chars; input_words();

    char c; pair<int, string> word;
    for (int i = 0; i < q_chars; ++i){
        cin >> c;
        cout << words[c - 'a'][0].second << '\n';
        ++words[c - 'a'][0].first;

        word = words[c - 'a'][0];
        words[c - 'a'].erase(words[c - 'a'].begin());
        insert_word(word, c - 'a');

        //output_words();
    }

    return 0;
}
