#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef long long lli;
typedef long double ld;

const lli INF = 1e18;

vector<lli> h;
vector<lli> v;
vector<vector<lli>> t;

lli func(lli n, lli k) {
    lli ans = 0;
    for (int mask = 0; mask < (1 << n); mask++) {
        lli p = -1;
        lli res = 0;
        for (int j = 0; j < n; j++) {
            if (mask & (1 << j)) {
                if (p > h[j + 1]) {
                    res = -1;
                    break;
                }
                res += v[j+1];
                p = h[j+1];
            }
        }
        if (res >= k)ans++;
    }
    return ans;
}

void solve()
{
    lli n, k;
    cin >> n >> k;
    h.resize(n + 2);
    v.resize(n + 2);
    h[n + 1] = INF;
    for (int i = 1; i <= n; i++)cin >> h[i] >> v[i];
    cout << func(n, k);
    return;
    lli m = (n / 2);
    t.resize(m + 1);
    for (int mask = 0; mask < (1 << m); mask++) {
        lli l = 0;
        lli curr = 0;
        lli p = -1;
        for (int j = 0; j < m; j++) {
            if (mask & (1 << j)) {
                l = j+1;
                if (h[j + 1] < p) {
                    curr = 0;
                    break;
                }
                curr += v[j + 1];
                p = h[j + 1];
            }
        }
        t[l].push_back(curr);
    }

    for (int i = 0; i <= m; i++)sort(t[i].begin(), t[i].end());
    lli ans = 0;
    for (int mask = 0; mask < (1 << (n - m)); mask++) {
        lli r = n + 1;
        lli curr = 0;
        lli p = -1;
        for (int j = 0; j < n - m; j++) {
            lli i = j + m+1;
            if (mask & (1 << j)) {
                if (r == n + 1)r = i;
                if (h[i] < p) {
                    curr = -1;
                    break;
                }
                curr += v[i];
                p = h[i];
            }
        }
        if (curr == -1)continue;
        for (int j = 0; j <= m; j++) {
            if (h[j] <= h[r]) {
                lli z = lower_bound(t[j].begin(), t[j].end(), k - curr)-t[j].begin();
                z = t[j].size() - z;
                ans += z;
            }
        }
    }

    lli ans2 = func(n, k);

    cout << ans;
}




int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 

    solve();
}

